﻿using System.Diagnostics;
using System.Threading;
using System.Xml;
using ff14bot;
using ff14bot.Behavior;
using ff14bot.Enums;
using ff14bot.Helpers;
using ff14bot.Interfaces;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.Objects;
using ff14bot.RemoteWindows;
using Clio.Utilities;
using RePear.Settings;
using System;
using System.Collections.Generic;
using System.IO;
using System.Configuration;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Timers;
using System.Windows;
using System.Windows.Forms;
using System.Windows.Media;
using TreeSharp;

using Action = TreeSharp.Action;

namespace Re_Pear
{
    public class Re_Pear : IBotPlugin
    {
		private static bool debug = false;
        #region Initialization Information
        public string Author { get { return " kagamihiiragi17; Wicked"; } }
        public string Description { get { return "Enables repairing on a certain interval"; } }
        public Version Version { get { return new Version(3, 0, 3); } }
        public string Name { get {
			if(!debug){
				return "RePear"; 
			}else{
				return "RePear - DEBUG";
			}
			
			} }

        public bool WantButton
        {
            get { return true; }
        }
        public string ButtonText
        {
            get { return "RePear"; }
        }
        public void OnButtonPress()
        {
            if (_form == null || _form.IsDisposed || _form.Disposing)
                _form = new RePear_Form();

            _form.ShowDialog();
        }
        public bool Equals(IBotPlugin other)
        {
            throw new NotImplementedException();
        }
        #endregion

        private Composite Root;
        private RePear_Form _form;
        public static RePearSettings settings = RePearSettings.instance;
        public static Vector3 InitialLocation;
        public static uint CurrentZone = 0;
        public static bool timetorepair = false;
        //public static bool timetorepair = true; // DEBUG
        public static bool repaired = false;
        public static System.Timers.Timer RepairTimer;
        public static RepairNPC RepairVendor = new RepairNPC();

        // Repair NPC Class
        public class RepairNPC
        {
            public string Name { get; set; }
            public Vector3 Location { get; set; }
            public string LocationName { get; set; }
            public bool ExtraMenu { get; set; }

            public RepairNPC()
            {
                Name = "";
                Location = Vector3.Zero;
                LocationName = "";
                ExtraMenu = true;
            }
            public RepairNPC(string newname, string newlocation, string newlocationname, bool newextramenu)
            {
                Name = newname;
                Location = new Vector3(newlocation);
                LocationName = newlocationname;
                ExtraMenu = newextramenu;
            }
        }

        // Initialize Lists
        public static List<RepairNPC> MiddleLaNoscea_List = new List<RepairNPC>();
        public static List<RepairNPC> EasternLaNoscea_List = new List<RepairNPC>();
        public static List<RepairNPC> LowerLaNoscea_List = new List<RepairNPC>();
        public static List<RepairNPC> WesternLaNoscea_List = new List<RepairNPC>();
        public static List<RepairNPC> UpperLaNoscea_List = new List<RepairNPC>();
        public static List<RepairNPC> OuterLaNoscea_List = new List<RepairNPC>();

        public static List<RepairNPC> CentralShroud_List = new List<RepairNPC>();
        public static List<RepairNPC> SouthShroud_List = new List<RepairNPC>();
        public static List<RepairNPC> EastShroud_List = new List<RepairNPC>();
        public static List<RepairNPC> NorthShroud_List = new List<RepairNPC>();

        public static List<RepairNPC> WesternThanalan_List = new List<RepairNPC>();
        public static List<RepairNPC> CentralThanalan_List = new List<RepairNPC>();
        public static List<RepairNPC> EasternThanalan_List = new List<RepairNPC>();
        public static List<RepairNPC> SouthernThanalan_List = new List<RepairNPC>();
        public static List<RepairNPC> NorthernThanalan_List = new List<RepairNPC>();

        public static List<RepairNPC> CoerthasCentralHighlands_List = new List<RepairNPC>();

        public static List<RepairNPC> MorDhona_List = new List<RepairNPC>();

        public static Dictionary<uint, List<RepairNPC>> LocationDictionary = new Dictionary<uint, List<RepairNPC>>();

		//Populate the list of vendors.
        private static void PopulateLists()
        {
            MiddleLaNoscea_List.Add(new RepairNPC("Merchant & Mender", "201.709, 98.42287, -206.1036", "Summerford Farms", true));

            EasternLaNoscea_List.Add(new RepairNPC("Merchant & Mender", "-36.2142, 71.75401, -37.01686", "Wineport", true));
            EasternLaNoscea_List.Add(new RepairNPC("Merchant & Mender", "460.3798, 17.12659, 486.5948", "Costa del Sol", true));

            LowerLaNoscea_List.Add(new RepairNPC("Merchant & Mender", "201.2207, 14.09601, 677.4546", "Moraby Drydocks", true));
            LowerLaNoscea_List.Add(new RepairNPC("Merchant & Mender", "-1.693787, 8.921356, 865.3544", "Candlekeep Quay", true));
            LowerLaNoscea_List.Add(new RepairNPC("Merchant & Mender", "554.4365, 89.02531, -49.82074", "Red Rooster Stead", true));

            WesternLaNoscea_List.Add(new RepairNPC("Merchant & Mender", "667.4143, 9.82882, 494.5602", "Swiftperch", true));
            WesternLaNoscea_List.Add(new RepairNPC("Merchant & Mender", "240.2533, -24.99897, 231.4336", "Aleport", true));
            WesternLaNoscea_List.Add(new RepairNPC("Merchant & Mender", "55.55798, -3.11828, 65.65955", "Camp Skull Valley", true));
            WesternLaNoscea_List.Add(new RepairNPC("Merchant & Mender", "19.4552, -10.31952, -64.10321", "North Tidegate", true));
            WesternLaNoscea_List.Add(new RepairNPC("Merchant & Mender", "-90.86749, -24.78893, 83.9093", "South Tidegate", true));

            UpperLaNoscea_List.Add(new RepairNPC("Junkmonger", "-329.6712, -2.533815, 136.2782", "Memeroon's Trading Post", true));
            UpperLaNoscea_List.Add(new RepairNPC("Junkmonger", "234.4854, -0.9121512, 248.2795", "Jijiroon's Trading Post", true));
            UpperLaNoscea_List.Add(new RepairNPC("Merchant & Mender", "427.2678, 4.098778, 115.2819", "Camp Bronze Lake", true));

            OuterLaNoscea_List.Add(new RepairNPC("Merchant & Mender", "-102.0371, 64.20702, -202.9908", "Camp Overlook", true));

            CentralShroud_List.Add(new RepairNPC("Merchant & Mender", "16.18976, -8.010208, -15.64056", "Bentbranch Meadows", true));
            CentralShroud_List.Add(new RepairNPC("Merchant & Mender", "82.59705, -7.893894, -103.3494", "The Bannock", true));
            CentralShroud_List.Add(new RepairNPC("Merchant & Mender", "175.616, -31.9986, 319.3254", "The Mirror Planks", true));

            SouthShroud_List.Add(new RepairNPC("Independent Arms Mender", "161.9745, 9.536184, -60.10535", "Quarrymill", false));
            SouthShroud_List.Add(new RepairNPC("Arms Supplier & Mender", "-164.7356, 9.869228, -76.69026", "Buscarron's Druthers", true));
            SouthShroud_List.Add(new RepairNPC("Merchant & Mender", "-214.313, 21.12917, 367.2389", "Camp Tranquil", true));

            EastShroud_List.Add(new RepairNPC("Merchant & Mender", "-213.9468, 2.324794, 300.4348", "The Hawthorne Hut", true));
            EastShroud_List.Add(new RepairNPC("Encampment Clothier & Tailor", "16.03717, -4.596201, 220.5081", "Little Solace", true));
            EastShroud_List.Add(new RepairNPC("Merchant & Mender", "-480.9186, 8.031123, 201.9226", "Fullflower Comb", true));
            EastShroud_List.Add(new RepairNPC("Merchant & Mender", "-577.0746, 12.55929, 102.5664", "Sweetbloom Pier", true));

            NorthShroud_List.Add(new RepairNPC("Merchant & Mender", "8.236346, -44.73338, 220.8371", "Fallgourd Float", true));
            NorthShroud_List.Add(new RepairNPC("Merchant & Mender", "332.2346, -5.550671, 332.4788", "Treespeak Stables", true));
            NorthShroud_List.Add(new RepairNPC("Tool Supplier & Mender", "420.7882, -3.795246, -123.4023", "Hyrstmill", true));

            WesternThanalan_List.Add(new RepairNPC("Merchant & Mender", "42.52686, 45.65809, -266.8345", "Horizon", true));
            WesternThanalan_List.Add(new RepairNPC("Merchant & Mender", "207.1716, 52.03812, 134.1726", "Scorpion Crossing", true));
            WesternThanalan_List.Add(new RepairNPC("Merchant & Mender", "-316.64, 33.27094, 391.9889", "Silver Bazaar Docks", true));
            WesternThanalan_List.Add(new RepairNPC("Merchant & Mender", "-306.508, 18.74717, -147.1123", "Crescent Cove", true));
            WesternThanalan_List.Add(new RepairNPC("Merchant & Mender", "-463.1617, 23.02054, -379.8878", "Vesper Bay", true));

            CentralThanalan_List.Add(new RepairNPC("Merchant & Mender", "-8.346741, -2.04808, -149.3401", "Black Brush Station", true));

            EasternThanalan_List.Add(new RepairNPC("Merchant & Mender", "-405.7696, -54.1446, 97.03169", "Camp Drybone", true));
            EasternThanalan_List.Add(new RepairNPC("Merchant & Mender", "-533.5012, 4.599574, -238.3917", "The Golden Bazaar", true));

            SouthernThanalan_List.Add(new RepairNPC("Merchant & Mender", "-157.3663, 27.18813, -434.9279", "Little Ala Mhigo", true));
            SouthernThanalan_List.Add(new RepairNPC("Merchant & Mender", "-278.7976, 8, 378.8662", "Forgotten Springs", true));

            NorthernThanalan_List.Add(new RepairNPC("Merchant & Mender", "-26.24441, 6.9845, 475.4407", "Camp Bluefog", true));
            NorthernThanalan_List.Add(new RepairNPC("Merchant & Mender", "-3.250244, 43.13602, 32.66956", "Ceruleum Processing Plant", true));

            CoerthasCentralHighlands_List.Add(new RepairNPC("Merchant & Mender", "242.8968, 302, -255.2822", "Camp Dragonhead", true));
            CoerthasCentralHighlands_List.Add(new RepairNPC("Merchant & Mender", "235.3743, 222.2132, 322.271", "First Dicasterial Observatorium of Aetherial and Astrological Phenomena", true));
            CoerthasCentralHighlands_List.Add(new RepairNPC("Merchant & Mender", "-413.0204, 210.8949, -273.961", "Whitebrim Front", true));

            MorDhona_List.Add(new RepairNPC("Independent Mender", "48.12084, 31.1198, -734.6162", "Revenant's Toll", false));
            MorDhona_List.Add(new RepairNPC("Merchant & Mender", "430.5944, -5.326402, -453.0861", "Saint Coinach's Find", true));

            LocationDictionary.Add(134, MiddleLaNoscea_List);
            LocationDictionary.Add(137, EasternLaNoscea_List);
            LocationDictionary.Add(135, LowerLaNoscea_List);
            LocationDictionary.Add(138, WesternLaNoscea_List);
            LocationDictionary.Add(139, UpperLaNoscea_List);
            LocationDictionary.Add(180, OuterLaNoscea_List);

            LocationDictionary.Add(148, CentralShroud_List);
            LocationDictionary.Add(153, SouthShroud_List);
            LocationDictionary.Add(152, EastShroud_List);
            LocationDictionary.Add(154, NorthShroud_List);

            LocationDictionary.Add(140, WesternThanalan_List);
            LocationDictionary.Add(141, CentralThanalan_List);
            LocationDictionary.Add(145, EasternThanalan_List);
            LocationDictionary.Add(146, SouthernThanalan_List);
            LocationDictionary.Add(147, NorthernThanalan_List);

            LocationDictionary.Add(155, CoerthasCentralHighlands_List);

            LocationDictionary.Add(156, MorDhona_List);
        }

        public static Vector3 GetNearestVendor()
        {
            Vector3 vendorlocation = Vector3.Zero;
            if (WorldManager.ZoneId != 134 && WorldManager.ZoneId != 137 && WorldManager.ZoneId != 135 &&
               WorldManager.ZoneId != 138 && WorldManager.ZoneId != 139 && WorldManager.ZoneId != 180 &&
               WorldManager.ZoneId != 148 && WorldManager.ZoneId != 153 && WorldManager.ZoneId != 152 &&
               WorldManager.ZoneId != 154 && WorldManager.ZoneId != 140 && WorldManager.ZoneId != 141 &&
               WorldManager.ZoneId != 145 && WorldManager.ZoneId != 146 && WorldManager.ZoneId != 147 &&
               WorldManager.ZoneId != 155 && WorldManager.ZoneId != 156)
            {
                RepairVendor = new RepairNPC("No Vendor", "0, 0, 0", "No Vendor", false);
                return Vector3.Zero;
            }
            foreach (RepairNPC vendor in LocationDictionary[WorldManager.ZoneId])
            {
                if (vendorlocation == Vector3.Zero)
                {
                    vendorlocation = vendor.Location;
                    RepairVendor = vendor;
                }
                else
                {
                    if (Vector3.Distance(Core.Player.Location, vendor.Location) < Vector3.Distance(Core.Player.Location, vendorlocation))
                    {
                        vendorlocation = vendor.Location;
                        RepairVendor = vendor;
                    }
                }
            }

            return vendorlocation;
        }

        public static void SetVendor()
        {
            Vector3 vendorlocation = Vector3.Zero;
            if (WorldManager.ZoneId != 134 && WorldManager.ZoneId != 137 && WorldManager.ZoneId != 135 &&
               WorldManager.ZoneId != 138 && WorldManager.ZoneId != 139 && WorldManager.ZoneId != 180 &&
               WorldManager.ZoneId != 148 && WorldManager.ZoneId != 153 && WorldManager.ZoneId != 152 &&
               WorldManager.ZoneId != 154 && WorldManager.ZoneId != 140 && WorldManager.ZoneId != 141 &&
               WorldManager.ZoneId != 145 && WorldManager.ZoneId != 146 && WorldManager.ZoneId != 147 &&
               WorldManager.ZoneId != 155 && WorldManager.ZoneId != 156)
            {
                RepairVendor = new RepairNPC("No Vendor", "0, 0, 0", "No Vendor", false);
                return;
            }
            foreach (RepairNPC vendor in LocationDictionary[WorldManager.ZoneId])
            {
                if (vendorlocation == Vector3.Zero)
                {
                    vendorlocation = vendor.Location;
                    RepairVendor = vendor;
                }
                else
                {
                    if (Vector3.Distance(Core.Player.Location, vendor.Location) < Vector3.Distance(Core.Player.Location, vendorlocation))
                    {
                        vendorlocation = vendor.Location;
                        RepairVendor = vendor;
                    }
                }
            }
            Logging.Write(Colors.SkyBlue, "[RePear] Current zone set to " + CurrentZone);
            Logging.Write(Colors.SkyBlue, "[RePear] Vendor set to " + RepairVendor.LocationName + " at " + RepairVendor.Location);
        }

        public static bool IsZoneValid()
        {
            if (WorldManager.ZoneId != 134 && WorldManager.ZoneId != 137 && WorldManager.ZoneId != 135 &&
               WorldManager.ZoneId != 138 && WorldManager.ZoneId != 139 && WorldManager.ZoneId != 180 &&
               WorldManager.ZoneId != 148 && WorldManager.ZoneId != 153 && WorldManager.ZoneId != 152 &&
               WorldManager.ZoneId != 154 && WorldManager.ZoneId != 140 && WorldManager.ZoneId != 141 &&
               WorldManager.ZoneId != 145 && WorldManager.ZoneId != 146 && WorldManager.ZoneId != 147 &&
               WorldManager.ZoneId != 155 && WorldManager.ZoneId != 156)
            {
				Logging.Write(Colors.SkyBlue, "[RePear] Current zone is INVALID");
                return false;
            }
            else
            {
				Logging.Write(Colors.SkyBlue, "[RePear] Current zone is VALID");
				return true;
            }
        }

        #region Init
        public void OnInitialize()
        {
            PopulateLists();
        }
        public void OnShutdown()
        {

        }
        public void OnEnabled()
        {
            Logging.Write(Colors.SkyBlue, "[RePear] v" + Version.ToString() + " Enabled");
            CurrentZone = WorldManager.ZoneId;
            SetVendor();
            Root = CreateBehaviorLogic();
            RepairTimer = new System.Timers.Timer();
            RepairTimer.AutoReset = false;
            RepairTimer.Elapsed += delegate(object sender, ElapsedEventArgs e)
            {
                timetorepair = true;
            };
            Root.Start(null);
        }
        public void OnDisabled()
        {
            Logging.Write(Colors.SkyBlue, "[RePear] Stopping Timer...");
            RepairTimer.Stop();
            Logging.Write(Colors.SkyBlue, "[RePear] Disabled");
            Root.Stop(null);
            Root = null;

        }
        #endregion

        private static Composite CreateBehaviorLogic()
        {
            return new PrioritySelector(
                new Decorator(ret => WorldManager.ZoneId != CurrentZone,
                    new Action(r =>
                    {
                        SetVendor();
                        CurrentZone = WorldManager.ZoneId;
						if(debug)Logging.Write(Colors.Red, "[RePear] 0 - I believe I'm initializing");
                    }
                    )
                ),
                new Decorator(ret => timetorepair && WorldManager.ZoneId == CurrentZone && IsZoneValid(),
                    new PrioritySelector(
                        new Decorator(ret => (	Poi.Current.Type == PoiType.None || 
												Poi.Current.Type == PoiType.Wait || 
												(Poi.Current.Type == PoiType.Fate && !FateManager.WithinFate)) 
												&& !repaired,
                            new Action(r =>
                            {
                                RepairTimer.Stop();
                                InitialLocation = Core.Player.Location;
                                Poi.Clear("[RePear] Clearing POI so we can repair...");
                                Poi.Current = new Poi(new HotSpot(RepairVendor.Location, 0), PoiType.Vendor);
                                if(debug)Logging.Write(Colors.Red, "[RePear] 1 - Moving to " + RepairVendor.LocationName + " Vendor");
                            }
                            )
                        ),
						new Decorator(ret => Poi.Current.Type == PoiType.Vendor && !repaired && Vector3.Distance(Core.Player.Location, Poi.Current.Location) > 3,
							CommonBehaviors.MoveTo(ret => Poi.Current.Location)
                        ),
						new Decorator(ret => Poi.Current.Type == PoiType.Vendor && MovementManager.IsMoving && !repaired && Vector3.Distance(Core.Player.Location, Poi.Current.Location) <= 3,
                            new Action(r =>
							{
								if(debug)Logging.Write(Colors.Red, "[RePear] Do I get here 2");
								ff14bot.Managers.MovementManager.MoveForwardStop();
							}
							)
                        ),
                        new Decorator(ret => !repaired && !MovementManager.IsMoving && Poi.Current.Location == RepairVendor.Location && Vector3.Distance(Core.Player.Location, Poi.Current.Location) <= 3,
                            new PrioritySelector(
								new Decorator(ret => !repaired && !Core.Player.HasTarget,
									new Sequence(
										new Action(r => TargetVendor()),
										new Sleep(1,2),
										new Action(r => {
											Core.Player.CurrentTarget.Interact();
											if(debug)Logging.Write(Colors.Red, "[RePear] Do I get here 3");
										})
									)
								),
								new Decorator(ret => !repaired && SelectYesno.IsOpen,
									new Action(r =>
									{
										SelectYesno.ClickYes();
										repaired = true;
										if(debug)Logging.Write(Colors.Red, "[RePear] I think I just repaired??");
									}
									)
								),
								new Decorator(ret => !repaired && Repair.IsOpen,
									new Action(r =>
									{
										Repair.RepairAll();
									}
									)
								),
								new Decorator(ret => !repaired && SelectIconString.IsOpen,
									new Sequence(
										new Sleep(1,2),
										new Action(r => ClickRepair())
									)
								)
							)
                        ),
						new Decorator(ret => repaired && Repair.IsOpen,
							new Action(r =>
							{
								Repair.Close();
							}
							)
						),
                        new Decorator(ret => Poi.Current.Type == PoiType.Vendor && repaired,
                            new Action(r =>
                            {
                                Poi.Clear("[RePear] Reached " + RepairVendor.LocationName + " Vendor and Repaired!");
                                if (BotManager.Current.Name != "Fate Bot" && BotManager.Current.Name != "Order Bot")
                                {
                                    Poi.Current = new Poi(new HotSpot(InitialLocation, 0), PoiType.Hotspot);
                                }
                                else
                                {
									if(debug)Logging.Write(Colors.Red, "[RePear] Not a fate bot");
                                    Logging.Write(Colors.SkyBlue, "[RePear] Resuming " + BotManager.Current.Name + " from here!");
                                    timetorepair = false;
                                    repaired = false;
                                }
                            }
                            )
                        ),
                        new Decorator(ret => Poi.Current.Type == PoiType.Hotspot && repaired && Vector3.Distance(Core.Player.Location, Poi.Current.Location) >= 5 && BotManager.Current.Name != "Fate Bot" && BotManager.Current.Name != "Order Bot",
                            new Action(r =>
                            {
                                Navigator.MoveToPointWithin(Poi.Current.Location, 1, "[RePear] Moving back to initial location...");
                            }
                            )
                        ),
                        new Decorator(ret => Poi.Current.Type == PoiType.Hotspot && repaired && Vector3.Distance(Core.Player.Location, Poi.Current.Location) < 5 && BotManager.Current.Name != "Fate Bot" && BotManager.Current.Name != "Order Bot",
                            new Action(r =>
                            {
                                CommonBehaviors.MoveStop();
                                Poi.Clear("[RePear] Returned back to where we were!");
                                timetorepair = false;
                                repaired = false;
                            }
                            )
                        )
                    )
                ),
                new Decorator(ret => RepairTimer.Enabled == false && timetorepair == false,
                    new Action(r =>
                    {
                        RepairTimer.Interval = (settings.Hours * 3600000) + (settings.Minutes * 60000);
                        Logging.Write(Colors.SkyBlue, "[RePear] Repair interval set as " + settings.Hours + " hours and " + settings.Minutes + " minutes.");
                        RepairTimer.Start();
                        Logging.Write(Colors.SkyBlue, "[RePear] Starting Timer");
                    }
                    )
                )
            );
        }

        public static void TargetVendor()
        {
            try
            {
                GameObjectManager.GetObjectByName(RepairVendor.Name).Target();
            }
            catch
            {
                Logging.Write(Colors.SkyBlue, "[RePear] Error targeting vendor...");
                Logging.Write(Colors.SkyBlue, "[RePear] VENDOR - Name: " + RepairVendor.Name + "Location: " + RepairVendor.Location);
            }
        }
		
		public static void ClickRepair()
        {
            var lines = ff14bot.RemoteWindows.SelectIconString.Lines();
			
			int line = lines.Count - 2;
			
			SelectIconString.ClickSlot((uint)line);
        }

        #region Pulse
        public void OnPulse()
        {
            try
            {
                Root.Tick(null);
                if (Root.LastStatus != RunStatus.Running)
                {
                    Root.Stop(null);
                    Root.Start(null);
                }
            }
            catch (Exception e)
            {
                Logging.WriteException(e);
                Root.Stop(null);
                Root.Start(null);
                throw;
            }
        }
        #endregion
    }
}